/*
TEMPLATE FOR WORKSHOP
Encompasses: Balloon Reaching End of Path, Health bar
 */


void setup() {
  size(800, 500);
  loadHeartIcon();
}

void draw() {
  background(#add558);
  drawHealthBar();
}
 

/*
  Method to check if the balloon has made it to the end of the path, calculates total distance of path versus balloon's total distance
  TODO:
    - fill in blank1 with the proper variable from this method to add to the total path length
    - fill in blank2 with the variable to correctly check if the distance the balloon has travelled is longer or equal to the path
  
*/
// Similar code to distance along path
boolean atEndOfPath(float travelDistance) {
  float totalPathLength = 0;
  for (int i = 0; i < points.size() - 1; i++) {
    PVector currentPoint = points.get(i);
    PVector nextPoint = points.get(i + 1);
    float distance = dist(currentPoint.x, currentPoint.y, nextPoint.x, nextPoint.y);
    totalPathLength += blank1;
  }
  if (travelDistance >= blank2) return true; // This means the total distance travelled is enough to reach the end
  return false;
}

// ------- HP SYSTEM --------
/*
  Heath-related variables:
 int health: The player's total health.
 This number decreases if balloons pass the end of the path (offscreen), currentely 11 since there are 11 balloons.
 PImage heart: the heart icon to display with the healthbar.
 */
int health = 11;  //variable to track user's health
PImage heart;

/*
  Method to load the image needed in drawHealthBar()
*/
void loadHeartIcon() {
  heart = loadImage("heart.png");
}

/*
  Method to draw the healthbar at bottom right of the screen
  TODO:
    - fill in blank1 with the variable that will correctly display the user's current health
    - fill in blank2 with the PImage identifier for the heart icon
  Note: feel free to experiment with the colours by changing the hex or RGB values inside the fill() commands.
*/
void drawHealthBar() {
  //draw healthbar outline
  stroke(0, 0, 0);
  strokeWeight(0);
  fill(#830000);
  rect(721, 455, 132, 20);

  //draw healthbar
  noStroke();
  rectMode(CORNER);
  fill(#FF3131);
  rect(655, 445.5, health*12, 20); //the healthbar that changes based on hp
  rectMode(CENTER);
  noFill();

  //write text
  stroke(0, 0, 0);
  textSize(14);
  fill(255, 255, 255);
  text("Health:   "+blank1, 670, 462);

  //put the heart.png image on screen
  imageMode(CENTER);
  image(blank2, 650, 456);
  noFill();
}
